<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>polylib: arithmetic_errors.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.6 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
<h1>arithmetic_errors.h</h1><a href="source_2arith_2arithmetic__errors_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/* </span>
<a name="l00002"></a>00002 <span class="comment"> * $Id: arithmetic_errors.h,v 1.4 2006/03/15 19:59:37 verdoolaege Exp $</span>
<a name="l00003"></a>00003 <span class="comment"> *</span>
<a name="l00004"></a>00004 <span class="comment"> * managing arithmetic errors...</span>
<a name="l00005"></a>00005 <span class="comment"> * detecting and managing arithmetic errors on Values should be</span>
<a name="l00006"></a>00006 <span class="comment"> * systematic. These macros gives a C++ look and feel to this</span>
<a name="l00007"></a>00007 <span class="comment"> * management. </span>
<a name="l00008"></a>00008 <span class="comment"> *</span>
<a name="l00009"></a>00009 <span class="comment"> * (c) CA et FC, Sept 1997</span>
<a name="l00010"></a>00010 <span class="comment"> *</span>
<a name="l00011"></a>00011 <span class="comment"> * $Log: arithmetic_errors.h,v $</span>
<a name="l00012"></a>00012 <span class="comment"> * Revision 1.4  2006/03/15 19:59:37  verdoolaege</span>
<a name="l00013"></a>00013 <span class="comment"> * arith: add some missing consts</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * Revision 1.3  2004/02/08 21:53:27  kienhuis</span>
<a name="l00016"></a>00016 <span class="comment"> * Update from Fabien Coelho, via Bart Kienhuis</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * I've updated here in the C3/Linear library the arithmetic_error</span>
<a name="l00019"></a>00019 <span class="comment"> * package that I developped (with others) to handle exceptions in C.</span>
<a name="l00020"></a>00020 <span class="comment"> * It adds a simple callback feature which is needed for pips here.</span>
<a name="l00021"></a>00021 <span class="comment"> * If you do not use it, it should not harm;-)</span>
<a name="l00022"></a>00022 <span class="comment"> *</span>
<a name="l00023"></a>00023 <span class="comment"> * Revision 1.34  2003/09/03 13:59:46  coelho</span>
<a name="l00024"></a>00024 <span class="comment"> * ++</span>
<a name="l00025"></a>00025 <span class="comment"> *</span>
<a name="l00026"></a>00026 <span class="comment"> * Revision 1.33  2003/09/03 13:35:34  coelho</span>
<a name="l00027"></a>00027 <span class="comment"> * no more callback.</span>
<a name="l00028"></a>00028 <span class="comment"> *</span>
<a name="l00029"></a>00029 <span class="comment"> * Revision 1.32  2003/08/18 14:55:38  coelho</span>
<a name="l00030"></a>00030 <span class="comment"> * callback fix.</span>
<a name="l00031"></a>00031 <span class="comment"> *</span>
<a name="l00032"></a>00032 <span class="comment"> * Revision 1.31  2003/08/18 14:16:45  coelho</span>
<a name="l00033"></a>00033 <span class="comment"> * NULL callback added.</span>
<a name="l00034"></a>00034 <span class="comment"> *</span>
<a name="l00035"></a>00035 <span class="comment"> * Revision 1.30  2003/06/13 13:59:55  coelho</span>
<a name="l00036"></a>00036 <span class="comment"> * hop.</span>
<a name="l00037"></a>00037 <span class="comment"> *</span>
<a name="l00038"></a>00038 <span class="comment"> * Revision 1.29  2000/07/27 15:01:55  coelho</span>
<a name="l00039"></a>00039 <span class="comment"> * hop.</span>
<a name="l00040"></a>00040 <span class="comment"> *</span>
<a name="l00041"></a>00041 <span class="comment"> * Revision 1.28  2000/07/26 09:11:58  coelho</span>
<a name="l00042"></a>00042 <span class="comment"> * hop.</span>
<a name="l00043"></a>00043 <span class="comment"> *</span>
<a name="l00044"></a>00044 <span class="comment"> * Revision 1.27  2000/07/26 09:07:32  coelho</span>
<a name="l00045"></a>00045 <span class="comment"> * *** empty log message ***</span>
<a name="l00046"></a>00046 <span class="comment"> *</span>
<a name="l00047"></a>00047 <span class="comment"> * Revision 1.26  2000/07/26 09:06:32  coelho</span>
<a name="l00048"></a>00048 <span class="comment"> * the_last_just_thrown_exception declared.</span>
<a name="l00049"></a>00049 <span class="comment"> *</span>
<a name="l00050"></a>00050 <span class="comment"> * Revision 1.25  2000/07/26 08:41:40  coelho</span>
<a name="l00051"></a>00051 <span class="comment"> * RETHROW added.</span>
<a name="l00052"></a>00052 <span class="comment"> *</span>
<a name="l00053"></a>00053 <span class="comment"> * Revision 1.24  1998/10/26 14:37:48  coelho</span>
<a name="l00054"></a>00054 <span class="comment"> * constants moved out.</span>
<a name="l00055"></a>00055 <span class="comment"> *</span>
<a name="l00056"></a>00056 <span class="comment"> * Revision 1.23  1998/10/26 14:36:13  coelho</span>
<a name="l00057"></a>00057 <span class="comment"> * constants explicitely defined in .h.</span>
<a name="l00058"></a>00058 <span class="comment"> *</span>
<a name="l00059"></a>00059 <span class="comment"> * Revision 1.22  1998/10/24 15:18:26  coelho</span>
<a name="l00060"></a>00060 <span class="comment"> * THROW macro updated to tell its source.</span>
<a name="l00061"></a>00061 <span class="comment"> *</span>
<a name="l00062"></a>00062 <span class="comment"> * Revision 1.21  1998/10/24 14:33:08  coelho</span>
<a name="l00063"></a>00063 <span class="comment"> * parser exception added.</span>
<a name="l00064"></a>00064 <span class="comment"> *</span>
<a name="l00065"></a>00065 <span class="comment"> * Revision 1.20  1998/10/24 14:32:45  coelho</span>
<a name="l00066"></a>00066 <span class="comment"> * simpler macros.</span>
<a name="l00067"></a>00067 <span class="comment"> *</span>
<a name="l00068"></a>00068 <span class="comment"> * Revision 1.19  1998/10/24 09:22:47  coelho</span>
<a name="l00069"></a>00069 <span class="comment"> * size update.</span>
<a name="l00070"></a>00070 <span class="comment"> *</span>
<a name="l00071"></a>00071 <span class="comment"> * Revision 1.18  1998/10/24 09:21:45  coelho</span>
<a name="l00072"></a>00072 <span class="comment"> * const added to constants.</span>
<a name="l00073"></a>00073 <span class="comment"> *</span>
<a name="l00074"></a>00074 <span class="comment"> */</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="preprocessor">#if !defined(linear_arithmetic_error_included)</span>
<a name="l00077"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#15a0338e1c704fe0a35195b6ddd5dc45">00077</a> <span class="preprocessor"></span><span class="preprocessor">#define linear_arithmetic_error_included</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>
<a name="l00079"></a>00079 <span class="preprocessor">#include &lt;setjmp.h&gt;</span>
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#afc39b4cb7a07fefadbdaeb9f8753679">00081</a> <span class="keyword">typedef</span> void (*<a class="code" href="source_2arith_2arithmetic__errors_8h.html#afc39b4cb7a07fefadbdaeb9f8753679">exception_callback_t</a>)(<span class="keyword">const</span> <span class="keywordtype">char</span> *, <span class="keyword">const</span> <span class="keywordtype">char</span> *, int);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="comment">/*</span>
<a name="l00084"></a>00084 <span class="comment">const unsigned int overflow_error = 1;</span>
<a name="l00085"></a>00085 <span class="comment">const unsigned int simplex_arithmetic_error = 2;</span>
<a name="l00086"></a>00086 <span class="comment">const unsigned int user_exception_error = 4;</span>
<a name="l00087"></a>00087 <span class="comment">const unsigned int parser_exception_error = 8;</span>
<a name="l00088"></a>00088 <span class="comment">const unsigned int any_exception_error = ~0;</span>
<a name="l00089"></a>00089 <span class="comment">*/</span>
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">/* use gnu cpp '__FUNCTION__' extension if possible.</span>
<a name="l00092"></a>00092 <span class="comment"> */</span>
<a name="l00093"></a>00093 <span class="preprocessor">#if defined(__GNUC__)</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span><span class="preprocessor">#define __CURRENT_FUNCTION_NAME__ __FUNCTION__</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00096"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#fb9d6e881bafb0485a90b7c3c7bfe46c">00096</a> <span class="preprocessor"></span><span class="preprocessor">#define __CURRENT_FUNCTION_NAME__ "&lt;unknown&gt;"</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099 <span class="comment">/* 'const' out because of cproto 4.6. FC 13/06/2003 */</span>
<a name="l00100"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#8e5fdcdfe948aeed8558f0d81392e941">00100</a> <span class="preprocessor">#define EXCEPTION extern unsigned int</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00102"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#748af154884693013ee5f03878988dbe">00102</a> <span class="preprocessor">#define THROW(what) \</span>
<a name="l00103"></a>00103 <span class="preprocessor">   (throw_exception(what, __CURRENT_FUNCTION_NAME__, __FILE__, __LINE__))</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#221261b286628ee622df9588446d503e">00105</a> <span class="preprocessor">#define CATCH(what)                                                     \</span>
<a name="l00106"></a>00106 <span class="preprocessor">   if (setjmp(*push_exception_on_stack(what, __CURRENT_FUNCTION_NAME__, \</span>
<a name="l00107"></a>00107 <span class="preprocessor">                                     __FILE__, __LINE__)))</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#8211465bb59b0e6b8c374b440965dbb4">00109</a> <span class="preprocessor">#define UNCATCH(what)                                           \</span>
<a name="l00110"></a>00110 <span class="preprocessor">     (pop_exception_from_stack(what, __CURRENT_FUNCTION_NAME__, \</span>
<a name="l00111"></a>00111 <span class="preprocessor">                               __FILE__, __LINE__))</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span>
<a name="l00113"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#d2746371528bdf15c3910b7bf217dac0">00113</a> <span class="preprocessor">#define TRY else</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00115"></a>00115 <span class="keyword">extern</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="source_2arith_2arithmetic__errors_8h.html#9dbd1094abce0128b2995c91d701349d">the_last_just_thrown_exception</a>;
<a name="l00116"></a><a class="code" href="source_2arith_2arithmetic__errors_8h.html#c8d720dd87a0d11d335c873336c65cee">00116</a> <span class="preprocessor">#define RETHROW() THROW(the_last_just_thrown_exception)</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>
<a name="l00118"></a>00118 <span class="preprocessor">#endif </span><span class="comment">/* linear_arithmetic_error_included */</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="comment">/* end of it.</span>
<a name="l00121"></a>00121 <span class="comment"> */</span>
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Tue Sep 15 18:33:58 2009 for polylib by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.6 </small></address>
</body>
</html>
